package com.example.aped.communication;

import android.content.Context;
import android.util.Log;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.Volley;
import org.json.JSONObject;
import java.io.File;
import kotlin.NotImplementedError;

public class Communicator {
    private String address;
    private int port;
    private RequestQueue requestQueue;

    public Communicator(String address, int port, Context context) {
        this.address = address;
        this.port = port;
        requestQueue = Volley.newRequestQueue(context);
    }

    public void read(String deviceName, Response.Listener<JSONObject> responseListener) {
        String requestString = "http://" + address + ":" + port + "/device/" + deviceName + "/";
        JsonObjectRequest request = new JsonObjectRequest(
                Request.Method.GET,
                requestString,
                null,
                responseListener,
                error -> Log.e("Communicator", "Error during READ: " + error.getMessage())
        );
        requestQueue.add(request);
    }

    public void write(String deviceName, JSONObject message, Response.Listener<JSONObject> responseListener) {
        String requestString = "http://" + address + ":" + port + "/device/" + deviceName + "/";
        JsonObjectRequest request = new JsonObjectRequest(
                Request.Method.POST,
                requestString,
                message,
                responseListener,
                error -> {
                    Log.e("Communicator", "Error during WRITE: " + error.getMessage()); error.printStackTrace(); }
        );
        requestQueue.add(request);
    }

    public void uploadXML(File xmlFile) {
        throw new NotImplementedError();
    }

    public void downloadXML() {
        throw new NotImplementedError();
    }
}
